//
//  Lambda:
//  . CApplication
//
//  (c) copyright 1998,2000 by Stefan Reuther <Streu@gmx.de>
//
#ifndef APPLICATION_H
#define APPLICATION_H

#include "node.h"

extern int unify_count;                  // Profiling fr Typ-Inferenz...
extern int i_reduce, k_reduce, s_reduce; // ...und SKI-Reduktion

//
//  Applikation "(expr value)"
//
class CApplication : public CNode {
    CNode* expr;
    CNode* value;

    CNode* reduce0(bool red_expr);
public:
    CApplication(CNode* aexpr, CNode* avalue) : expr(aexpr), value(avalue) {}
    virtual ~CApplication() { delete expr; delete value; }
  	
    virtual CNode* reduce();
    virtual CNode* copy();
    virtual void print(std::ostream& out, TPrintContext pc);
    virtual TVariable* freevars(TVariable* p);
    virtual bool alpha(TVariable* fv);
    virtual void global_alpha(TVariable* fv, int action);
    virtual CNode* replace(std::string& sym, CNode* rep);
    virtual bool numcheck(TNumCheck& nc);
    virtual bool listcheck(TListCheck& lc);
    virtual void listout(std::ostream& o, int n, char delim);
    virtual CNode* eta(int stage, std::string s);
    virtual CTypePtr get_type(TTypeInfo& ti, TTypeItem* local_types);
    virtual int count_atoms() { return expr->count_atoms() + value->count_atoms() + 1; }

    virtual CNode* ski();
    virtual CNode* ski_lambda(std::string);
    
    virtual CApplication* applic() { return this; }
    virtual CNode* ski_reduce();

    virtual CNode* ioreduce(std::ostream& os, TIoContext& ioc);

    virtual bool calls_macro(std::string);
    virtual CNode* replace_macro(std::string mac, std::string sym);
};

#endif
