//
//  Lambda: Kurze Zahlen-Schreibweise
//  . CNumber
//
//  (c) copyright 1998,2000 by Stefan Reuther <Streu@gmx.de>
//
#ifndef NUMBER_H
#define NUMBER_H

#include "node.h"

class CNumber : public CNode {
    int val;
    CNode *expanded;
 public:
    CNumber(int aval, CNode* aexp=0) : val(aval), expanded(aexp) {}
    virtual ~CNumber() { if(expanded) delete expanded; }
  	
    virtual CNode* eta(int stage, std::string s);
    virtual CNode* reduce();
    virtual CLambda* lambda();
    virtual CNode* copy();
    virtual void print(std::ostream& out, TPrintContext pc);
    virtual TVariable* freevars(TVariable* p);
    virtual bool alpha(TVariable* fv);
    virtual void global_alpha(TVariable* fv, int action);
    virtual CNode* replace(std::string& sym, CNode* rep);
    virtual bool numcheck(TNumCheck& nc);
    virtual bool listcheck(TListCheck& lc) { return false; }
    virtual int count_atoms() { return expanded?expanded->count_atoms():1; }
    virtual CTypePtr get_type(TTypeInfo& ti, TTypeItem* local_types);
    virtual CNode* ski();
    virtual CNode* ski_lambda(std::string);
    void makevalue();
};

#endif
