//
//  Lambda: Scanner
//
//  (c) copyright 1998,2000 by Stefan Reuther <Streu@gmx.de>
//

#ifndef SCANNER_H
#define SCANNER_H

#include <iostream>
#include <string>
enum TType {
    TBAD,       // falsches Token
    TLEFT,      // (
    TRIGHT,     // )
    TLAMBDA,    // ? \ lambda
    TDOT,       // .
    TSEMI,      // ;
    TEOF,       //
    TMACRO,     // <name>
    TNUMBER,    // Zahl
    TSLASH,     // /
    TLEFTSQR,   // [
    TRIGHTSQR,  // ]
    TCOLON,     // :
    TSYMBOL,    // name
    TARROW      // ->
};

extern TType ttype;         // aktueller Tokentyp
extern std::string tstr;    // aktueller Tokenname bei Makro/Symbol
extern int tint;            // aktueller Tokenwert bei Zahlen
extern std::istream* inp;   // aktueller Eingabedatenstrom
extern bool badtoken;       // true=Fehler gefunden
extern bool freeform_flag;  // false=newline wird als Semikolon akzeptiert
extern std::string prompt;
extern bool noalias_flag;   // true=nur "Hauptwerte" der Symbole erkennen

TType getsymbol();
void startscan();
void resetscan();
void readeol();
void openstream(std::istream* p);
void closefile();
bool readtty();
std::ostream& error_message();

bool looking_at(const char* what);

#endif
