//
//  Lambda: Symbol (freie/gebundene Variable)
//  . CSymbol
//
//  (c) copyright 1998,2000 by Stefan Reuther <Streu@gmx.de>
//
#ifndef SYMBOL_H
#define SYMBOL_H

#include <iostream>
#include <string>
#include "node.h"

class CSymbol : public CNode {
    std::string name;
public:
    CSymbol(const std::string& aname) : name(aname) {}
    virtual ~CSymbol() {}

    virtual CNode* eta(int stage, std::string s);
    virtual CNode* reduce();
    virtual CNode* copy();
    virtual void print(std::ostream& out, TPrintContext pc);
    virtual TVariable* freevars(TVariable* p);
    virtual bool alpha(TVariable* fv);
    virtual void global_alpha(TVariable* fv, int action);
    virtual CNode* replace(std::string& sym, CNode* rep);
    virtual bool numcheck(TNumCheck& nc);
    virtual bool listcheck(TListCheck& lc);
    virtual void listout(std::ostream& o, int n, char delim);
    virtual CTypePtr get_type(TTypeInfo& ti, TTypeItem* local_types);
    virtual CNode* ski();
    virtual CNode* ski_lambda(std::string);
};

#endif
